package com.realnet.order_estimation.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.order_estimation.Entity.Type;
import com.realnet.order_estimation.Services.TypeService ;


@RequestMapping(value = "/Type")
 @CrossOrigin("*") 
@RestController
public class TypeController {
	@Autowired
	private TypeService Service;

@Value("${projectPath}")
	private String projectPath;
 


	@PostMapping("/Type")
		  public Type Savedata(@RequestBody Type data) {
		Type save = Service.Savedata(data)	;

		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Type/{id}")
	public  Type update(@RequestBody Type data,@PathVariable Integer id ) {
		Type update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Type/getall/page")
	public Page<Type> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Type> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Type")
	public List<Type> getdetails() {
		 List<Type> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Type")
	public List<Type> getallwioutsec() {
		 List<Type> get = Service.getdetails();		
		return get;
}
@GetMapping("/Type/{id}")
	public  Type  getdetailsbyId(@PathVariable Integer id ) {
		Type  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Type/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}



}